﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HeuristicLab.Algorithms.Bandits {
  public class RandomPolicy : BanditPolicy {
    private readonly Random random;
    public RandomPolicy(Random random, int numActions)
      : base(numActions) {
      this.random = random;
    }

    public override int SelectAction() {
      return random.Next(NumActions);
    }
    public override void UpdateReward(int action, double reward) {
      // do nothing
    }
    public override void Reset() {
      // do nothing
    }
  }
}
