﻿using System;
using System.Collections.Generic;

namespace HeuristicLab.Problems.GrammaticalOptimization {

  // symbols are characters, possible nonterminal symbols are : 'A'..'Z'
  // phrases and sentences are strings
  // each symbol is only on element in a string

  public interface IGrammar {
    char SentenceSymbol { get; }
    IEnumerable<char> NonTerminalSymbols { get; }
    IEnumerable<char> TerminalSymbols { get; }
    IEnumerable<char> Symbols { get; }

    IEnumerable<string> GetAlternatives(char nt);
    IEnumerable<string> GetTerminalAlternatives(char nt);
    IEnumerable<string> GetNonTerminalAlternatives(char nt);

    int MinPhraseLength(string phrase);
    int MaxPhraseLength(string phrase);
    string CompleteSentenceRandomly(Random random, string phrase, int maxLen);

    bool IsTerminal(char symbol);
    bool IsNonTerminal(char symbol);
  }
}
